#!/usr/bin/env python

book_list = ["Il nome della rosa", "Il pendolo di Foucault", "Guerra e pace", "Anna Karenina",
             "Delitto e castigo", "I fratelli Karamazov", "L'idiota",
             "I promessi sposi"]

# -----------------------------

#  books = {"Delitto e castigo": "Fedor Dostoevskji", "I fratelli Karamazov": "Fedor Dostoevskji"}
#  books["Il nome della rosa"] = "Umberto Eco"
#  books["Il pendolo di Foucault"] = "Umberto Eco"
#  books["Guerra e pace"] = "Lev Tolstoj"
#  books["Anna Karenina"] = "Lev Tolstoj"
#  books["I promessi sposi"] = "Alessandro Manzoni"
#  
#  print sorted(set(books.values()))
#  
#  
#  books_per_author = {}
#  for title, author in books.items():
#      books_per_author.setdefault(author, []).append(title)
#  


# -----------------------------
books = {}
books["Umberto Eco"] = ["Il nome della rosa", "Il pendolo di Foucault"]
books["Lev Tolstoj"] = ["I fratelli Karamazov", "Anna Karenina"]
books["Alessandro Manzoni"] = ["I promessi sposi"]

print sorted(books.keys())

for i in books:
    print i, len(books[i])

print

for author, book_list in books.items():
    print author, len(book_list)

all_books = []
for titles in books.values():
    all_books.extend(titles)

print filter(lambda title: 'a' not in title, all_books)
print [title for title in all_books if 'a' not in title]

books_per_title = {}
for author, titles in books.items():
    for title in titles:
        books_per_title[title] = author

items = books_per_title.items()

# [('Il nome della rosa', 'Umberto Eco'), ...]

items.sort(key=lambda pair: pair[1])

print items

#sorted_titles = map(lambda pair: pair[0], items)
sorted_titles = [item[0] for item in items]

print sorted_titles


for author, titles in books.items():
    for title in titles:
        print "{author} ha scritto il libro '{title}'.".format(author=author, title=title)

