/* clib.h */

#include <iostream>

class Complex
{
public:
    Complex(double re=0.0, double im=0.0) : m_re(re), m_im(im) { }
    double real() const { return this->m_re; }
    double imag() const { return this->m_im; }
    double mod() const;
    Complex operator *(const Complex & z) const;
    Complex operator +(const Complex & z) const;
private:
    double m_re;
    double m_im;
};


extern std::ostream & operator <<(std::ostream & os, const Complex & z);
